<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\property;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\property\PropertyHead;
use app\common\model\property\PropertyOrder;
use app\common\lists\ListsSearchInterface;
use app\common\model\property\PropertyUser;


/**
 * PropertyOrder列表
 * Class PropertyOrderLists
 * @package app\adminapi\lists
 */
class PropertyOrderLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function setSearch(): array
    {
        return [
            '=' => ['property_head_id', 'property_user_id', 'remark', 'order_status', 'work_id'],

        ];
    }
    public function queryWhere()
    {
        $where = [];
        if(isset($this->params['head_name']) && !empty($this->params['head_name'])){
            $property_head_ids = PropertyHead::where('head_name', 'like', '%'.$this->params['head_name'].'%')->column('id');
            $where[] = ['property_head_id','IN',$property_head_ids];
        }
        if(isset($this->params['householder_name']) && !empty($this->params['householder_name'])){
            $property_user_ids = PropertyUser::where('householder_name', 'like', '%'.$this->params['householder_name'].'%')->column('id');
            $where[] = ['property_user_id','IN',$property_user_ids];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function lists(): array
    {
        return PropertyOrder::with(['propertyHead','propertyUser'])->where($this->searchWhere)->where($this->queryWhere())
            ->field(['id', 'property_head_id', 'property_user_id', 'remark', 'order_status', 'work_id','address','create_time'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function count(): int
    {
        return PropertyOrder::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}